//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * eXgZbgAbveXg
 * @author Junpee
 */

#include "Test/stdafx.h"
#include "LampUnit/TestSetupTest.h"
#include "LampUnit/TestCaseTest.h"

//------------------------------------------------------------------------------
// eXgs
void TestSetupTest::runTest(){
	TestSuite suite("DoubleTest");
	suite.addTest(new TestCaseTest::SuccessTestCase());
	suite.addTest(new TestCaseTest::FailureTestCase());
	TestSetup setupTest(&suite);
	TestEquals(2, setupTest.getCountTestCases());
	TestEquals("DoubleTest", setupTest.getName());
	TestEquals("Suite DoubleTest", setupTest.toString());

	TestResult result;
	setupTest.run(&result);
	TestEquals(2, result.getRunCount());
	TestEquals(1, result.getFailureCount());
	TestAssert(!result.wasSuccessful());

}
//------------------------------------------------------------------------------
